package com.zcloud.personnel.positioning.web;

import com.zcloud.personnel.positioning.api.TerminalBindServiceI;
import com.zcloud.personnel.positioning.dto.TerminalBindAddCmd;
import com.zcloud.personnel.positioning.dto.TerminalBindPageQry;
import com.zcloud.personnel.positioning.dto.TerminalBindUpdateCmd;
import com.zcloud.personnel.positioning.dto.clientobject.TerminalBindCO;
import com.alibaba.cola.dto.MultiResponse;
import com.alibaba.cola.dto.PageResponse;
import com.alibaba.cola.dto.Response;
import com.alibaba.cola.dto.SingleResponse;
import com.jjb.saas.framework.auth.model.SSOUser;
import com.jjb.saas.framework.auth.utils.AuthContext;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * web-adapter
 *
 * @Author fangjiakai
 * @Date 2026-07-07
 */
@Api(tags = "人员定位终端绑定记录")
@RequestMapping("/${application.gateway}/terminalBind")
@RestController
@AllArgsConstructor
public class TerminalBindController {
    private final TerminalBindServiceI terminalBindService;

    @ApiOperation("新增")
    @PostMapping("/save")
    public SingleResponse<TerminalBindCO> add(@Validated @RequestBody TerminalBindAddCmd cmd) {
        fillCorpinfo(cmd);
        return terminalBindService.add(cmd);
    }

    @ApiOperation("分页")
    @PostMapping("/list")
    public PageResponse<TerminalBindCO> page(@RequestBody TerminalBindPageQry qry) {
        return terminalBindService.listPage(qry);
    }

    @ApiOperation("所有数据")
    @GetMapping("/listAll")
    public MultiResponse<TerminalBindCO> listAll() {
        return MultiResponse.of(terminalBindService.listAll());
    }

    @ApiOperation("详情")
    @GetMapping("/{id}")
    public SingleResponse<TerminalBindCO> getInfoById(@PathVariable("id") Long id) {
        return SingleResponse.of(terminalBindService.queryById(id));
    }

    @ApiOperation("删除")
    @DeleteMapping("/{id}")
    public Response remove(@PathVariable("id") Long id) {
        terminalBindService.remove(id);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("删除多个")
    @DeleteMapping("/ids")
    public Response removeBatch(@RequestParam Long[] ids) {
        terminalBindService.removeBatch(ids);
        return SingleResponse.buildSuccess();
    }

    @ApiOperation("修改")
    @PutMapping("/edit")
    public SingleResponse edit(@Validated @RequestBody TerminalBindUpdateCmd cmd) {
        fillCorpinfo(cmd);
        terminalBindService.edit(cmd);
        return SingleResponse.buildSuccess();
    }

    private void fillCorpinfo(TerminalBindAddCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        if (ssoUser != null && ssoUser.getCompanyId() != null) {
            cmd.setCorpinfoId(String.valueOf(ssoUser.getCompanyId()));
        }
    }

    private void fillCorpinfo(TerminalBindUpdateCmd cmd) {
        SSOUser ssoUser = AuthContext.getCurrentUser();
        if (ssoUser != null && ssoUser.getCompanyId() != null) {
            cmd.setCorpinfoId(String.valueOf(ssoUser.getCompanyId()));
        }
    }
}
